=== share/hedgewars/Data/CMakeLists.txt ===
foreach(dir
    Fonts
    Forts
    Graphics
    Locale
    Maps
    Missions
    Music
    Names
    Scripts
    Sounds
    Themes
    misc
    )
    add_subdirectory(${dir})
endforeach(dir)

if(${GL2})
    add_subdirectory(Shaders)
endif(${GL2})
