=== debian/changelog ===
hedgewars (1.0.3-4build1) resolute; urgency=medium

  * Rebuild against new GHC ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 01 Nov 2025 08:54:52 +0100

hedgewars (1.0.3-4) unstable; urgency=medium

  * Refresh patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Aug 2025 01:38:05 +0200

hedgewars (1.0.3-3) unstable; urgency=medium

  * Add patch to fix cmake errors on ppc64el

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 05 Aug 2025 01:37:57 +0200

hedgewars (1.0.3-2) unstable; urgency=medium

  * Don't build dynamic haskell-based server

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Aug 2025 16:25:01 +0200

hedgewars (1.0.3-1) unstable; urgency=medium

  * New upstream version 1.0.3
  * Drop patches now upstream/superseeded
    - d/p/74.patch
    - d/p/9cd8d7748199.patch
    - d/p/c09063ea0267.patch

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 04 Aug 2025 12:31:01 +0200

hedgewars (1.0.2-13) unstable; urgency=medium

  * Team upload.
  * Remove extraneous dependency on qt5-style-plugins (Closes: #1102266)

 -- Alexandre Detiste <tchet@debian.org>  Mon, 07 Apr 2025 08:23:02 +0200

hedgewars (1.0.2-12) unstable; urgency=medium

  * Add one patch for metadata path fixes

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Jan 2025 12:48:40 +0100

hedgewars (1.0.2-11) unstable; urgency=medium

  * Add patch proposed upstream to fix build failure with ffmpeg 6.0,
    enable again videorec
  * Depend on ffmpeg again
  * Drop some old version constraints, already satisfied since o-o-stable
  * Bump std-version to 4.7.0, no changes required

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 27 Jan 2025 09:15:38 +0100

hedgewars (1.0.2-10) unstable; urgency=medium

  * Add one more Control.Monad for Pas2C
    - thanks L299Ah!

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sun, 03 Nov 2024 23:31:33 +0100

hedgewars (1.0.2-9.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Add a patch to add missing Control.Monad imports. (Closes: #1085260)

 -- Dmitry Shachnev <mitya57@debian.org>  Sun, 03 Nov 2024 21:21:34 +0300
